; copyright: Stephan Bartl working at gk-medizinmechanik.at, 1st version on October 8th, 2014
; script name: XYAHK_customInlineRenameMouse++
; version 0.002
#NoEnv  ; Recommended for performance and compatibility with future AutoHotkey releases.
#Persistent
#SingleInstance force
SetTitleMatchMode, 2
SetKeyDelay, 0
SetMouseDelay, 0
titleMatchStringForXY := "XYplorer ahk_class ThunderRT6FormDC"
clicks := mouseX1 := mouseY1 := 0

;code for mapping the double click based on http://www.autohotkey.com/board/topic/16321-map-a-double-left-mouse-click-to-a-single-key/?p=105959 by user jonny 
#if (editNNHavingFocus := _XYOneOfEditNNsHasFocus("Edit15|Edit17|Edit18|Edit19", titleMatchStringForXY)) and clicks = 0
~LButton::
CoordMode, Mouse, Window
MouseGetPos, mouseX1, mouseY1
clicks := 1
SetTimer, ClickWait, 400
return

#if (editNNHavingFocus := _XYOneOfEditNNsHasFocus("Edit15|Edit17|Edit18|Edit19", titleMatchStringForXY)) and clicks > 0
LButton::
CoordMode, Mouse, Window
clicks++
if (clicks = 2)
{
	MouseGetPos, mouseX2, mouseY2
	if (mouseX1 = mouseX2 and mouseY1 = mouseY2)
	{
		ControlGetText, textOfEdit, %editNNHavingFocus%, %titleMatchStringForXY%
		caretPos := _Edit_CaretGetPos(editNNHavingFocus, titleMatchStringForXY)
		selectFromPos := 0
		selectToPos := caretPos
		Loop, parse, textOfEdit
		{
			if (A_Index <= caretPos)
			{
				if A_LoopField is not alnum
					selectFromPos := A_Index
			}
			else if (A_Index > caretPos)
				if A_LoopField is alnum
					selectToPos++
				else
					break
		}
		_Edit_Select(selectFromPos, selectToPos, editNNHavingFocus, titleMatchStringForXY)
	}
	else
	{
		SetTimer, ClickWait, off
		clicks := 0
	}
}
else if (clicks = 3)
{
	MouseGetPos, mouseX3, mouseY3
	if (mouseX3 = mouseX2 and mouseY3 = mouseY2)
	{
		_Edit_Select(0, -1, editNNHavingFocus, titleMatchStringForXY)
	}
	else
	{
		SetTimer, ClickWait, off
		clicks := 0
	}
}
return

ClickWait:
SetTimer, ClickWait, off
clicks := 0
return
#if

_XYOneOfEditNNsHasFocus(listOfEditNNs, wintitle)
{
   ; This script retrieves the ahk_id (HWND) of the active window's focused control. - taken from the ahk help file
	GuiThreadInfoSize = 48
	VarSetCapacity(GuiThreadInfo, GuiThreadInfoSize)
	NumPut(GuiThreadInfoSize, GuiThreadInfo, 0)
	if not DllCall("GetGUIThreadInfo", uint, 0, str, GuiThreadInfo)
	{
		focusedHWND := 0
	}
	else
		focusedHWND := NumGet(GuiThreadInfo, 12)  ; Retrieve the hwndFocus field from the struct.
	
	returnValue := 0
	Loop, parse, listOfEditNNs, |
	{
		ControlGet, hEdit, hwnd, , %A_LoopField%, %wintitle%
		if (hEdit = focusedHWND)
			returnValue := A_LoopField
	}
	return returnValue
}

; Gets the current caret position (zero-based) of an edit control having input focus
; (at least for XYplorer inline-edit-controls).
; This function is IMHO preferable over ControlGet, outVar, CurrentCol, ... because
; the build in function is not reliable with the caret position around selections.
;
_Edit_CaretGetPos(editNNHavingFocus, wintitle)
{
	ControlGetFocus, focusedControl, %wintitle%
	if (focusedControl = editNNHavingFocus)
	{
		ControlGet, hEdit, hwnd, , %editNNHavingFocus%, %wintitle%
		ControlGetPos, editX, editY, editW, editH, %editNNHavingFocus%, %wintitle%
		CoordMode, Caret, Window
		_EM_CHARFROMPOS(hEdit, A_CaretX - editX, A_CaretY - editY, charPos, line)
	}
	else
		charPos := ""
	return charPos
}

;***** the following function from http://ahkscript.org/boards/viewtopic.php?f=5&t=4826&p=27883#p27857 by user "just me"
;***** alteration: made the returned index number zero-based
; ======================================================================================================================
; Gets information about the character closest to a specified point in the client area of an edit control.
; X, Y            -  the X- and Y-positions of the point.
; CharPos, Line   -  receive the character position and the line number.
; ======================================================================================================================
_EM_CHARFROMPOS(HWND, X, Y, ByRef CharPos, ByRef Line) {
   ; _EM_CHARFROMPOS = 0x00D7 -> msdn.microsoft.com/en-us/library/bb761566(v=vs.85).aspx
   CharPos := Line := 0
   CharLine := DllCall("User32.dll\SendMessage", "Ptr", HWND, "UInt", 0x00D7, "Ptr", 0, "UInt", (Y << 16) | X, "Ptr")
   CharPos := (CharLine & 0xFFFF)
   Line := (CharLine >> 16)
   Return True
}

;*******following functions from http://www.autohotkey.com/board/topic/20981-edit-control-functions/ by user Lexikos
; Standard parameters:
;   Control, WinTitle   If WinTitle is not specified, 'Control' may be the
;                       unique ID (hwnd) of the control.  If "A" is specified
;                       in Control, the control with input focus is used.
;
; Standard/default return value:
;   true on success, otherwise false.
_Edit_Standard_Params(ByRef Control, ByRef WinTitle) {  ; Helper function.
    if (Control="A" && WinTitle="") { ; Control is "A", use focused control.
        ControlGetFocus, Control, A
        WinTitle = A
    } else if (Control+0!="" && WinTitle="") {  ; Control is numeric, assume its a ahk_id.
        WinTitle := "ahk_id " . Control
        Control =
    }
}

; Selects text in a text box, given absolute character positions (starting at 0.)
;
; start:    Starting character offset, or -1 to deselect.
; end:      Ending character offset, or -1 for "end of text."
;
_Edit_Select(start=0, end=-1, Control="", WinTitle="")
{
    _Edit_Standard_Params(Control, WinTitle)
    SendMessage, 0xB1, start, end, %Control%, %WinTitle%  ; EM_SETSEL
    return (ErrorLevel != "FAIL")
}